From d86205c3ec49b0edadfa2b3e568b3d852f0a6e1f Mon Sep 17 00:00:00 2001
From: Frederic Cambus <fred@statdns.com>
Date: Mon, 12 Feb 2024 13:44:59 +0100
Subject: [PATCH] Add support to readelf for the PT_OPENBSD_SYSCALLS segment
 type.

binutils * readelf.c (get_segment_type): Handle PT_OPENBSD_SYSCALLS segment type.
include  * elf/common.h (PT_OPENBSD_SYSCALLS): Define.
---
 binutils/ChangeLog   | 5 +++++
 binutils/readelf.c   | 1 +
 include/ChangeLog    | 4 ++++
 include/elf/common.h | 1 +
 4 files changed, 11 insertions(+)

diff --git a/binutils/ChangeLog b/binutils/ChangeLog
index 438a45d77a8..b74847adcee 100644
--- a/binutils/ChangeLog
+++ b/binutils/ChangeLog
@@ -1,3 +1,8 @@
+2024-02-12  Frederic Cambus  <fred@statdns.com>
+
+	* readelf.c (get_segment_type): Handle PT_OPENBSD_SYSCALLS segment
+	type.
+
 2024-01-26  Nick Clifton  <nickc@redhat.com>
 
 	PR 31250
diff --git a/binutils/readelf.c b/binutils/readelf.c
index e3bf68064c1..6e3ac1baf6d 100644
--- a/binutils/readelf.c
+++ b/binutils/readelf.c
@@ -5105,6 +5105,7 @@ get_segment_type (Filedata * filedata, unsigned long p_type)
     case PT_OPENBSD_RANDOMIZE: return "OPENBSD_RANDOMIZE";
     case PT_OPENBSD_WXNEEDED: return "OPENBSD_WXNEEDED";
     case PT_OPENBSD_NOBTCFI: return "OPENBSD_NOBTCFI";
+    case PT_OPENBSD_SYSCALLS: return "OPENBSD_SYSCALLS";
     case PT_OPENBSD_BOOTDATA: return "OPENBSD_BOOTDATA";
 
     default:
diff --git a/include/ChangeLog b/include/ChangeLog
index 4b667bfa307..11c4b321a49 100644
--- a/include/ChangeLog
+++ b/include/ChangeLog
@@ -1,3 +1,7 @@
+2024-02-12  Frederic Cambus  <fred@statdns.com>
+
+	* elf/common.h (PT_OPENBSD_SYSCALLS): Define.
+
 2024-01-29  Jose E. Marchesi  <jose.marchesi@oracle.com>
 
 	* opcode/bpf.h (enum bpf_insn_id): Remove BPF_INSN_LDINDDW and
diff --git a/include/elf/common.h b/include/elf/common.h
index 6a66456cd22..832f9bd510f 100644
--- a/include/elf/common.h
+++ b/include/elf/common.h
@@ -496,6 +496,7 @@
 #define PT_OPENBSD_RANDOMIZE (PT_LOOS + 0x5a3dbe6)  /* Fill with random data.  */
 #define PT_OPENBSD_WXNEEDED  (PT_LOOS + 0x5a3dbe7)  /* Program does W^X violations.  */
 #define PT_OPENBSD_NOBTCFI   (PT_LOOS + 0x5a3dbe8)  /* No branch target CFI.  */
+#define PT_OPENBSD_SYSCALLS  (PT_LOOS + 0x5a3dbe9)  /* System call sites.  */
 #define PT_OPENBSD_BOOTDATA  (PT_LOOS + 0x5a41be6)  /* Section for boot arguments.  */
 
 /* Mbind segments */
-- 
2.39.3

